#pragma once

#include <vector>
#include <algorithm>
#include "Singleton.h"
#include "NotificationProxyInterface.h"

#define GT_NOTI_PROXY		CSingleton<CDefaultNotificationProxy>::Instance()

class CDefaultNotificationProxy : public INotificationProxy
#if defined(WIN32)	// __KEH_USE_LKWND__
	, public _ITinyWindowEvents
#else
	, public IGTRunLoopObserver
#endif
{
public:
	CDefaultNotificationProxy(void);
	virtual ~CDefaultNotificationProxy(void);

private:
	bool OnTimerProcess(WPARAM wParam, LPARAM lParam);
	bool OnSignalProcess(int nMsg, WPARAM wParam, LPARAM lParam);
	
protected:
#if defined(WIN32)	// __KEH_USE_LKWND__		
	BOOL ITinyWindow_OnWndProc(ITinyWindow * pWindow, UINT uMsg, WPARAM wParam, LPARAM lParam);
#else
	virtual bool OnGTRunLoopObserver_SourceEvent(GT_EVENT_HANDLE handle, GT_PARAM param1, GT_PARAM param2);
	virtual bool OnGTRunLoopObserver_TimerEvent(GT_EVENT_HANDLE handle, GT_PARAM param);
#endif	

private:
	void DoNotify(INotifyCommand *pCommand);
	void DoTimerJob(void);
public:
	virtual void Clear(void);
	virtual void Notify(INotifyCommand *pCommand);

private:
#if defined(WIN32)	// __KEH_USE_LKWND__	
	ITinyWindow *m_pWnd;
#else
	IGTEventDelegate *m_pEventDelegate;
#endif	

	DWORD m_pMainThreadID;

	std::list<INotifyCommand*> m_listTimerCommand;
};
